local _G = _G;
local GetTime, GetNumGroupMembers, IsInRaid, IsInGroup  = GetTime, GetNumGroupMembers, IsInRaid, IsInGroup
local strsplit = strsplit
local GetSpellInfo, GetChannelName = GetSpellInfo, GetChannelName
local GetStatusBarTexture = GetStatusBarTexture
local UnitGUID, UnitHealthMax, UnitHealth = UnitGUID, UnitHealthMax, UnitHealth
local string, ipairs, tonumber, select = string, ipairs, tonumber, select
local table_insert, table_remove , table_getn = table.insert, table.remove, table.getn
local print, string_format, string_gmatch, string_length, string_sub, math_floor= print, string.format, string.gmatch, string.len, string.sub, math.floor
local SetValue, Show, SetText, Hide = SetValue, Show, SetText, Hide
local CreateFrame, CreateFontString = CreateFrame, CreateFontString
local SetStatusBarTexture, SetBackdrop, SetBackdropBorderColor, SetBackdropColor = SetStatusBarTexture, SetBackdrop, SetBackdropBorderColor, SetBackdropColor
local SetHorizTile, SetMinMaxValues, SetPoint, SetHeight, SetStatusBarColor, SetWidth = SetHorizTile, SetMinMaxValues, SetPoint, SetHeight, SetStatusBarColor, SetWidth
local SetFont = SetFont
local red = RED_FONT_COLOR
local StopMovingOrSizing = StopMovingOrSizing
local GREEN_FONT_COLOR = GREEN_FONT_COLOR
red.r, red.g, red.b = 0.75, 0.05 ,0.05
local UnrealTargets = CreateFrame('Frame', "UnrealTargets", UIParent)
local ColorPickerFrame = ColorPickerFrame

					
local UnrealTargets_options = {};
local newtabs = true


function UnrealTargets:mysettings(arg1)
	--print (arg1.." loaded")
	if arg1 == "UnrealTargets" then
	   if not unrealtargetssettings then
			unrealtargetssettings = {
				['config'] = {
					['height'] = 15,
					['width'] = 150,
					['rafter_distance'] = 5,
					['posix'] = 1200,
					['posiy'] = 700,
					['barnamecut'] = 15,
					['castbarnamecut'] = 15,
					['color_r'] = 0.75,
					['color_g'] = 0.05,
					['color_b'] = 0.05,
					['color_a'] = 1,
				}
			}
			--print('ut 1')
		elseif unrealtargetssettings == nil then
			unrealtargetssettings  = {
				['config'] = {
					['height'] = 15,
					['width'] = 150,
					['rafter_distance'] = 5,
					['posix'] = 1200,
					['posiy'] = 700,
					['barnamecut'] = 15,
					['castbarnamecut'] = 15,
					['color_r'] = 0.75,
					['color_g'] = 0.05,
					['color_b'] = 0.05,
					['color_a'] = 1,
				}
			}
			--print('ut 2')
		else
			--print (unrealtargetssettings['config']['height'].." 45")
		end
	end
end

local unitdb = {}
unitdb.isinfight = false
unitdb.allunitguids = {}
unitdb.units = {}
unitdb.unitsmaxhp = {}
unitdb.slider = 0
unitdb.zone = true
unitdb.groupmembers = {}
unitdb.grouppets = {}
local myunits = {}
myunits.castTime = 0

unitdb.ignornpc = {47649 -- wildpilz
	,95582 -- Armee der toten
	,24207 -- Vogel
	,15439 -- Totem des Feuerelementars
	,29264 -- Geisterwolf
	,82521 -- Entweihen
	,3527 -- Totem des heilenden Flusses
	,60199 -- Rune der Macht
	,47243 -- Spiegelbild
	,59764 -- Totem der Heilungsflut
	,77789 -- Blingtron 5000
	,416 -- Wichtel
	,31216 -- Spiegelbild
	,5929 -- Totem des glühenden Magmas
	,93828 -- Trainingsattrappe
	,45322 -- Gefrorene Kugel
	,62982 -- Geistbeuger
	,61245 -- Totem der Energiespeicherung
	,54983 -- Treant
	,77934 -- Totem des Sturmelementars
	,77936 -- Großer Sturmelementar
	,55659 -- Wildwichtel
	,2523 -- Totem der Verbrennung
	,90610 -- Teufelsfeuermunition
	,78158 -- Verdammniswache
	,15438 -- Großer Feuerelementar
	,46490 -- Wächter der Uralten Könige
	,53006 -- Totem der Geistverbindung
	,59000 -- Terrorwache
	,47319 -- Gezielter Sprung
	,60849 -- Statue der Jadeschlange
	,92993 -- Spiegelbild
	,63508 -- Xuen
	,92624 -- Streitkolben
	,76168 -- Verheerer
	,92587 -- Schwert
	,92919 -- Restenergie
	,76933 -- Kristallprisma
	,11859 -- Verdammniswache
	,27893 -- Runenklinge
	,73967 -- Xuen
	,61146 -- Statue des Schwarzen Ochsen
	,35642 -- Jeeves
	,94729 -- Kohlenbecken des Erwachens
	,59607 -- Spektralerscheinung
	,59712 -- Totem des Steinbollwerks
	,96115 -- Schlachtstandarte von Vol'jins Kopfjägern
	,94852 -- Feenmondschwinge
	,19668 -- Schattengeist
	,89194 -- Ausgedörrte Echse
	,94922 -- Lady Jaina Prachtmeer
	,94946 -- Arthas Menethil
	,94879 -- Tyrande Wisperwind
	,92893 -- Axt
	,94925 -- Fürstin Sylvanas Windläufer
	,77726 -- Schattenreflexion
	,27829 -- Schwarzer Gargoyle
	,54569 -- Transzendenzgeist
	,76917 -- <Persönliches Hologramm>
	,5925 -- Totem der Erdung
	,15352 -- Großer Erdelementar
	,15430 -- Totem des Erdelementars
	,61029 -- Urfeuerelementar
	,60561 -- Totem des Erdgriffs
	,64571 -- Lichtbrunnen
	,61056 -- Urerdelementar
	,40703 -- Megazord
	,91326 -- Gul'dan
	,59717 -- Totem des Windwandelns
	,5913 -- Totem des Erdstoßes
	,92208 -- Verdammnisfeuergeist
	,59738 -- Hammer des Lichts
	,4277 -- Auge von Kilrogg
	,67235 -- Schattengeist
	,80302 -- Wächterkugel
	,86945 -- Hexenmeisterin von Haus Sonnenschwur
	,89 -- Höllenbestie
	,86933 -- Magierin des Kriegsspeers
	,69680 -- Sturmgeist
	,58542 -- Vergangenes Selbst
	 ,88380 -- Grunzerin
	,88393 -- Grunzerin
	,88391 -- Garnisonsschütze
	,67236 -- Geistbeuger
	,95455 -- Verderbter urzeitlicher Obelisk
	,88435 -- Wächter der Schmiede
	,78215 -- Verirorok
	,61711 -- Wassertotem
	,61714 -- Lufttotem
	,61713 -- Erdtotem
	,69792 -- Erdgeist
	,77942 -- Ursturmelementar
	,87061 -- Schattengeist
	,88050 -- allunitguids
	,31897 -- Lichtbrunnen
	,86946 -- Ausgestoßener Krallenpriester
	,62182 -- Amethystschieferjungtier
	,86964 -- Erdbinder der Blutmähnen
	,58997 -- Abyssal
	,86682 -- Pensionierter gorianischer Zenturio
	,69791 -- Feuergeist
	,59390 -- Spottendes Banner
	,48638 -- Schlachtstandarte der Gilde
	,84774 -- Tödliche Eisenfalle
	,83925 -- Eisenfalle
	,44199 -- Ring des Frosts
	,77894 -- Walter
	,95468 -- Satyr der Illidari
	,95469 -- Bösartiger Höllenhund
	,86951 -- Wolf aus Nagrand
	,86187 -- Tier
	,65282 -- Leerententakel
	,61712 -- Feuertotem
	,56194 -- Spinnenjungtier
	,90206 -- Schwester der Versuchung
	,93247 -- Dämonenportal
	,62005 -- Tier
	,33239 -- El Jonathanxd
	,86702 -- Verweilender Geist
	,59271 -- Dämonisches Tor
	--,94924 -- Eiserner Peon
	,81032 -- Croman
	,86180 -- Tier
	,86181 -- Tier
	,78001 -- Totem des Wolkenbruchs
	,1964 -- Treant
	,2630 -- Totem der Erdbindung
	,88054 -- Saberonleibwächter
	,88060 -- Wütender Zwicky
	,19921 -- Viper
	,10933 -- Giftige Schlange
	,80703 -- Totem des Windzorns
}

-- 90432 FAIL	

local db = {}
db.silencespells = {
	-- dk
	47476 -- strangulate
	-- druid
	,114237 -- glyph-of-fae-silence
	,78675 -- solar-beam
	-- mage
	,102051 -- frostjaw
	-- paladin
	,31935 -- avengers-shield
	-- priest
	,15487 -- silence
	-- rogue
	,703 -- garrote
	-- bloddelf racial
	,28730 -- arcane-torrent
	,50613 -- arcane-torrent
	,25046 -- arcane-torrent
	,155145 -- arcane-torrent
	,129597 -- arcane-torrent
	,69179 -- arcane-torrent
	,80483 -- arcane-torrent
}
db.stunspells = {
	-- dk
	108194 -- asphyxiate
	,91800 -- gnaw
	,47481 -- gnaw
	,91797 -- monstrous-blow
	,108200 -- remorseless-winter
	-- druid
	,22570 -- maim
	,5211 -- mighty-bash
	,1822 -- rake
	-- hunter
	,109248 -- binding-shot
	,19577 -- intimidation
	-- mage
	,44572 -- deep-freeze
	-- monk
	,119392 -- charging-ox-wave
	,113656 -- fists-of-fury
	,119381 -- leg-sweep
	-- paladin
	,853 -- hammer-of-justice
	,105593 -- fist-of-justice
	,119072 -- holy-wrath
	--rogue
	,1833 -- cheap-shot
	,408 -- kidney-shot
	-- shaman
	,80313 -- pulverize
	,108269 -- capacitor-totem
	,118905 -- static-charge
	-- warlock
	,89766 -- axe-toss
	,30283 -- shadowfury
	,1122 -- summon-infernal
	,112921 -- summon-abyssal
	-- warrior
	,46968 -- shockwave
	,107570 -- storm-bolt
	-- tauren racial
	,20549 -- war-stomp
}
db.incapacitatesspells = { --handlungsunfähig
	-- druid
	99 -- incapacitating-roar
	-- hunter
	,1499 -- freezing-trap
	,19386 -- wyvern-sting
	-- mage
	,118 -- polymorph sheep
	,28271-- polymorph turtle
	,28272 -- polymorph pig
	,61305 -- polymorph black cat
	,61721 -- polymorph rabbit
	,61780 -- polymorph pig 2
	,161353 -- polymorph polar bear cup
	,161354 -- polymorph monkey
	,161355 -- polymorph penguin
	,161372 -- polymorph turtle 2 
	,113724 -- ring-of-frost
	,82691 -- ring-of-frost
	,96369 -- ring-of-frost
	,140384 -- ring-of-frost
	-- monk
	,123394 -- glyph-of-breath-of-fire
	,115078 -- paralysis
	,116844 -- ring-of-peace
	-- paladin
	,20066 -- repentance
	-- priest
	,605 -- dominate-mind
	,88625 -- holy-word-chastise
	,64044 -- psychic-horror
	,9484 -- shackle-undead
	-- rogue
	,1776 -- gouge
	,6770 -- sap
	-- shaman
	,51514 -- hex
	-- warlock
	,710 -- banish
	,111397 -- blood-horror
	,6789 -- mortal-coil
	-- pandaren racial
	,107079 -- quaking-palm
}
db.disorientsspells = {
	--druid
	33786 -- cyclone
	-- mage
	,31661 -- dragons-breath
	-- paladin
	,115750 -- blinding-light
	,10326 -- turn-evil
	-- priest
	,8122 -- psychic-scream
	-- rogue
	,2094 -- blind
	-- warlock
	,5782 -- fear
	,130616 -- fear
	,118699 -- fear
	,5484 -- howl-of-terror
	,115268 -- mesmerize
	,6358 -- seduction
	-- warrior
	,5246 -- intimidating-shout
}	

	
function cmdut(arg)
	if arg == "test" then
		 for i, groupguid in ipairs(unitdb.groupmembers) do
			print('Player'..i..': '..groupguid)
		 end
		 for i, petguid in ipairs(unitdb.grouppets) do
			print('Pet'..i..': '..petguid)
		 end
	elseif  arg == "test2" then
		local preGC = collectgarbage("count")
		collectgarbage("collect")
		print("Collected " .. (preGC-collectgarbage("count")) .. " kB of garbage");
		collectgarbage()
		ResetCPUUsage()
	elseif  arg == "reset" then
		UnrealTargets:reset_frames()
	end	
end

function UnrealTargets:interrupt()
	myunits.bar = UnrealTargets:set_hp_frame(0, 0, 'mytestbar', UiParent)
	local testheightbar = 33
	local testwidthbar = 200
	myunits.bar:SetWidth(testwidthbar)
	myunits.bar:SetHeight(testheightbar)
	myunits.fontname = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	myunits.fontname:SetPoint("TOPLEFT", 0, 0)
	local targetname = UnrealTargets:cut_name('Interrupt')
	myunits.fontname:SetText(targetname)
	myunits.fontname:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")
	myunits.fonthppercent = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	myunits.fonthppercent:SetPoint("TOPRIGHT", 0, 0)
	myunits.fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")	
	myunits.bar:SetMovable(true)
	myunits.bar:EnableMouse(true)
	myunits.bar:RegisterForDrag("LeftButton")
	myunits.bar:SetScript("OnDragStart", myunits.bar.StartMoving)
	myunits.bar:SetScript("OnDragStop", myunits.bar.StopMovingOrSizing)
	myunits.castbar = UnrealTargets:set_hp_frame(0, -testheightbar/3, 'mytestbarcastline', myunits.bar)
	myunits.castbar:SetWidth(testwidthbar)
	myunits.castbar:SetHeight(testheightbar/3)
	local green = GREEN_FONT_COLOR 
	myunits.castbar:SetStatusBarColor(green.r, green.g, green.b)
	myunits.castbar:Hide()
	local icon = select(3,GetSpellInfo(740))
	myunits.icon = CreateFrame("StatusBar", 'mytestbaricon', myunits.bar)
	myunits.icon:SetStatusBarTexture(icon)
	myunits.icon:SetWidth(testheightbar)
	myunits.icon:SetHeight(testheightbar)
	myunits.icon:SetPoint("Topleft", -testheightbar, 0)
	myunits.icon:Hide()
end

function UnrealTargets:option_slider(name, uiparent, anocher, posix, posiy, minvale, maxvalue, titlename, databasevalue) 
	local slider = CreateFrame("Slider", name ,uiparent,"OptionsSliderTemplate")
	slider:SetPoint(anocher, posix, posiy)
	slider.textLow = _G[name.."Low"]
	slider.textHigh = _G[name.."High"]
	slider.text = _G[name.."Text"]
	slider:SetMinMaxValues(minvale, maxvalue)
	slider.minValue, slider.maxValue = slider:GetMinMaxValues() 
	slider.textLow:SetText(slider.minValue)
	slider.textHigh:SetText(slider.maxValue)
	slider.text:SetText(titlename)
	slider:SetValue(databasevalue)
	slider:SetValueStep(1)
	
	slider.editBox = CreateFrame("EditBox", "edittest"..name, slider, "InputBoxTemplate")
	slider.editBox:SetWidth(30)
	slider.editBox:SetHeight(8)
	slider.editBox:SetBackdropColor(0, 0, 0, 0.8)
	slider.editBox:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
	slider.editBox:SetPoint("Topleft", 62, -20)
	slider.editBox:ClearFocus(self)
	slider.editBox:SetAutoFocus(false)	
	return slider
end

function round(num, ...)
	local idp = ... or 0
	local mult = 10^(idp or 0)
	return math_floor(num * mult + 0.5) / mult
end

function UnrealTargets:set_hp_frame(posix, posiy, ...)
	local framename, myuiparent = ... or nil, UiParent
	local NewStatusBar = CreateFrame("StatusBar", framename, myuiparent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(unrealtargetssettings['config']['width'])
	NewStatusBar:SetHeight(unrealtargetssettings['config']['height'])
	NewStatusBar:SetPoint("CENTER",posix, posiy)
	NewStatusBar:SetStatusBarColor(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'])
	return NewStatusBar
end

SlashCmdList["cmdut"] = cmdut; 
SLASH_cmdut1 = "/utar";
SLASH_cmdut2 = "/UnrealTargets";
SLASH_cmdut3 = "/unrealtargets";
SLASH_cmdut4 = "/unrealtarget";
unitdb.slider ={}

UnrealTargets_options = {};
UnrealTargets_options.panel = CreateFrame("ScrollFrame", "UnrealTargetsPanel", UIParent );
UnrealTargets_options.panel.name = "UnrealTargets";
UnrealTargets_options.panel.okay = 
function (self)
	self.originalValue = MY_VARIABLE;
end
InterfaceOptions_AddCategory(UnrealTargets_options.panel)

local function showColorPicker(r,g,b,a,callback)
  ColorPickerFrame:SetColorRGB(r,g,b)
  ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a
  ColorPickerFrame.previousValues = {r,g,b,a}
  ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = callback, callback, callback
  ColorPickerFrame:Hide() -- Need to run the OnShow handler.
  ColorPickerFrame:Show()
end
 
local function create_color_template(posix, posiy)
	--frame
	local f = CreateFrame("FRAME" ,"barcolor" , UnrealTargetsPanel)
	f:SetSize(15,15)
	f:SetPoint("TOPLEFT", posix, posiy)
	--texture
	f.tex = f:CreateTexture(nil,"BACKGROUND",nil,-7)
	f.tex:SetAllPoints(f)
	f.tex:SetTexture(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'],
		unrealtargetssettings['config']['color_a'])
	--recolor callback function
	f.recolorTexture = function(color)
		local r,g,b,a
		if color then
			r,g,b,a = unpack(color)
		else
			r,g,b = ColorPickerFrame:GetColorRGB()
			a = OpacitySliderFrame:GetValue()
			--print("new? "..r.." "..g.." "..b)
			unrealtargetssettings['config']['color_r'] = r
			unrealtargetssettings['config']['color_g'] = g
			unrealtargetssettings['config']['color_b'] = b
			unrealtargetssettings['config']['color_a'] = a
		end
		
		f.tex:SetTexture(r, g, b, a)
	end
	f:EnableMouse(true)
	f:SetScript("OnMouseDown", function(self,button,...)
		if button == "LeftButton" then
			local r,g,b,a = self.tex:GetVertexColor()
			showColorPicker(r,g,b,a,self.recolorTexture)
		end
	end)
	return f
end

function UnrealTargets:Initialize()
	unrealtargetssettings['config']['height'] = unrealtargetssettings['config']['height'] or 25
	unrealtargetssettings['config']['width'] = unrealtargetssettings['config']['width'] or 150
	unrealtargetssettings['config']['rafter_distance'] = unrealtargetssettings['config']['rafter_distance'] or 5
	unrealtargetssettings['config']["posix"] = unrealtargetssettings['config']["posix"] or 1200
	unrealtargetssettings['config']["posiy"] = unrealtargetssettings['config']["posiy"] or 700
	unrealtargetssettings['config']["barnamecut"] = unrealtargetssettings['config']["barnamecut"] or 15
	unrealtargetssettings['config']["castbarnamecut"] = unrealtargetssettings['config']["castbarnamecut"] or 15
	unrealtargetssettings['config']['color_r'] = unrealtargetssettings['config']['color_r'] or 0.75
	unrealtargetssettings['config']['color_g'] = unrealtargetssettings['config']['color_g'] or 0.05
	unrealtargetssettings['config']['color_b'] = unrealtargetssettings['config']['color_b'] or 0.05
	unrealtargetssettings['config']['color_a'] = unrealtargetssettings['config']['color_a'] or 1
	
	UnrealTargets:raidgrid()
	local value2 = unrealtargetssettings['config']['height']
	local barcolor = create_color_template(15, -220)
	local name = "resetbutton"
	local template = "UIPanelButtonTemplate"
	local button = CreateFrame("Button", name, UnrealTargetsPanel, "UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate    
	button:SetSize(50,15)
	button:SetPoint("Topleft",10, -10)
	button.text = _G[name.."Text"]
	button.text:SetText("Reset")
	button:SetScript("OnClick", function(self, ...) 
		print("reset options")
		unrealtargetssettings['config']['height'] = 25
		unrealtargetssettings['config']['width'] = 150
		unrealtargetssettings['config']['rafter_distance'] = 5
		unrealtargetssettings['config']["posix"] = 1200
		unrealtargetssettings['config']["posiy"] = 700
		unrealtargetssettings['config']["barnamecut"] = 15
		unrealtargetssettings['config']["castbarnamecut"] = 15
		unrealtargetssettings['config']['color_r'] = 0.75
		unrealtargetssettings['config']['color_g'] = 0.05
		unrealtargetssettings['config']['color_b'] = 0.05
		unrealtargetssettings['config']['color_a'] = 1
		unitdb.slider.height:SetValue(unrealtargetssettings['config']['height'])
		unitdb.slider.width:SetValue(unrealtargetssettings['config']['width'])
		unitdb.slider.rafter_distance:SetValue(unrealtargetssettings['config']['rafter_distance'])
		unitdb.slider.barnamecut:SetValue(unrealtargetssettings['config']["barnamecut"])
		unitdb.slider.castbarnamecut:SetValue(unrealtargetssettings['config']["castbarnamecut"])
		unitdb.allframes:SetPoint('BOTTOMLEFT', unrealtargetssettings['config']['posix'], unrealtargetssettings['config']['posiy'])
		barcolor.tex:SetTexture(1, 0.1, 0.1, 1)
	end)
	
	unitdb.header1 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header1:SetPoint("Topleft",200, -40)
	unitdb.header1:SetText("Bar Options")
	unitdb.header1:SetFont("Fonts\\FRIZQT__.ttf",18,"OUTLINE")
	unitdb.header1:SetTextColor(red.r, red.g, red.b)
	unitdb.header2 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.header2:SetPoint("Topleft",35, -222)
	unitdb.header2:SetText("Barcolor")
	unitdb.header2:SetFont("Fonts\\FRIZQT__.ttf",12,"OUTLINE")

	
	-- barheight
	unitdb.slider.height = UnrealTargets:option_slider('height', UnrealTargetsPanel, "TOPLEFT", 10, -80, 4, 50, 'height', unrealtargetssettings['config']['height'])
	unitdb.slider.height:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['height'] = event
		unitdb.slider.height.editBox:SetText(event)
	end)
	unitdb.slider.height.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.height.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['height']
		if value > 50 then
			value = 50
		elseif value < 4 then
			value = 4
		end
		unitdb.slider.height.editBox:SetText(value)
		unrealtargetssettings['config']['height'] = value
		unitdb.slider.height:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.height.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.height.editBox:SetText(unrealtargetssettings['config']['height'])
		self:ClearFocus()
	end)
	
	-- barwidth
	unitdb.slider.width = UnrealTargets:option_slider('width', UnrealTargetsPanel, "TOPLEFT", 185, -80, 25, 500, 'width', unrealtargetssettings['config']['width'])
	unitdb.slider.width:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['width'] = event
		unitdb.slider.width.editBox:SetText(event)
	end)
	unitdb.slider.width.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.width.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['width']
		if value > 500 then
			value = 500
		elseif value < 25 then
			value = 25
		end
		unitdb.slider.width.editBox:SetText(value)
		unrealtargetssettings['config']['width'] = value
		unitdb.slider.width:SetValue(value)
		unitdb.allframes:SetWidth(value)
		self:ClearFocus()		
	end)
	unitdb.slider.width.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.width.editBox:SetText(unrealtargetssettings['config']['width'])
		self:ClearFocus()
	end)

	-- bar rafter distance
	unitdb.slider.rafter_distance = UnrealTargets:option_slider('rafter_distance', UnrealTargetsPanel, "TOPLEFT", 360, -80, 0, 25, "Bar-Distance", unrealtargetssettings['config']['rafter_distance'])
	unitdb.slider.rafter_distance:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['rafter_distance'] = event
		unitdb.slider.rafter_distance.editBox:SetText(event)
	end)
	unitdb.slider.rafter_distance.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.rafter_distance.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['rafter_distance']
		if value > 25 then
			value = 25
		elseif value < 0 then
			value = 0
		end
		unitdb.slider.rafter_distance.editBox:SetText(value)
		unrealtargetssettings['config']['rafter_distance'] = value
		unitdb.slider.rafter_distance:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.rafter_distance.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.rafter_distance.editBox:SetText(unrealtargetssettings['config']['rafter_distance'])
		self:ClearFocus()
	end)

	-- bar posi x
	-- unitdb.slider.posix = UnrealTargets:option_slider("posix", UnrealTargetsPanel, "TOPLEFT", 10, -140, -1000, 1000, "X-position", unrealtargetssettings['config']["posix"])
	-- unitdb.slider.posix:SetScript("OnValueChanged", function(self,event,arg1) 
		-- event = round(event)
		-- self:SetValue(event)
		-- unrealtargetssettings['config']["posix"] = event
		-- unitdb.slider.posix.editBox:SetText(event)
	-- end)
	-- unitdb.slider.posix.editBox:SetScript( "OnEnterPressed", function(self) 
		-- local value = unitdb.slider.posix.editBox:GetText()
		-- value = tonumber(value) or unrealtargetssettings['config']["posix"]
		-- if value > 1000 then
			-- value = 1000
		-- elseif value < -1000 then
			-- value = -1000
		-- end
		-- unitdb.slider.posix.editBox:SetText(value)
		-- unrealtargetssettings['config']["posix"] = value
		-- unitdb.slider.posix:SetValue(value)
		-- self:ClearFocus()		
	-- end)
	-- unitdb.slider.posix.editBox:SetScript( "OnEscapePressed", function(self)
		-- unitdb.slider.posix.editBox:SetText(unrealtargetssettings['config']["posix"])
		-- self:ClearFocus()
	-- end)

	-- -- bar posi y
	-- unitdb.slider.posiy = UnrealTargets:option_slider("posiy", UnrealTargetsPanel, "TOPLEFT", 185, -140, -1000, 1000, "Y-position", unrealtargetssettings['config']["posiy"])
	-- unitdb.slider.posiy:SetScript("OnValueChanged", function(self,event,arg1) 
		-- event = round(event)
		-- self:SetValue(event)
		-- unrealtargetssettings['config']["posiy"] = event
		-- unitdb.slider.posiy.editBox:SetText(event)
	-- end)
	-- unitdb.slider.posiy.editBox:SetScript( "OnEnterPressed", function(self) 
		-- local value = unitdb.slider.posiy.editBox:GetText()
		-- value = tonumber(value) or unrealtargetssettings['config']["posiy"]
		-- if value > 1000 then
			-- value = 1000
		-- elseif value < -1000 then
			-- value = -1000
		-- end
		-- unitdb.slider.posiy.editBox:SetText(value)
		-- unrealtargetssettings['config']["posiy"] = value
		-- unitdb.slider.posiy:SetValue(value)
		-- self:ClearFocus()		
	-- end)
	-- unitdb.slider.posiy.editBox:SetScript( "OnEscapePressed", function(self)
		-- unitdb.slider.posiy.editBox:SetText(unrealtargetssettings['config']["posiy"])
		-- self:ClearFocus()
	-- end)
	
	-- cut bar name 
	unitdb.slider.barnamecut = UnrealTargets:option_slider("cut_barname", UnrealTargetsPanel, "TOPLEFT", 10, -140, 3, 100, "Barnamecut", unrealtargetssettings['config']["barnamecut"])
	unitdb.slider.barnamecut:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']["barnamecut"] = event
		unitdb.slider.barnamecut.editBox:SetText(event)
	end)
	unitdb.slider.barnamecut.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.barnamecut.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']["barnamecut"]
		if value > 100 then
			value = 100
		elseif value < 3 then
			value = 3
		end
		unitdb.slider.barnamecut.editBox:SetText(value)
		unrealtargetssettings['config']["barnamecut"] = value
		unitdb.slider.barnamecut:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.barnamecut.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.barnamecut.editBox:SetText(unrealtargetssettings['config']["barnamecut"])
		self:ClearFocus()
	end)
	
	-- cut castbar name 
	unitdb.slider.castbarnamecut = UnrealTargets:option_slider("castbarnamecut", UnrealTargetsPanel, "TOPLEFT", 185, -140, 3, 100, "Castbarnamecut", unrealtargetssettings['config']["castbarnamecut"])
	unitdb.slider.castbarnamecut:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']["castbarnamecut"] = event
		unitdb.slider.castbarnamecut.editBox:SetText(event)
	end)
	unitdb.slider.castbarnamecut.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.castbarnamecut.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']["castbarnamecut"]
		if value > 100 then
			value = 100
		elseif value < 3 then
			value = 3
		end
		unitdb.slider.castbarnamecut.editBox:SetText(value)
		unrealtargetssettings['config']["castbarnamecut"] = value
		unitdb.slider.castbarnamecut:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.castbarnamecut.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.castbarnamecut.editBox:SetText(unrealtargetssettings['config']["castbarnamecut"])
		self:ClearFocus()
	end)
	unitdb.slider.castbarnamecut:Hide()
	unitdb.slider.castbarnamecut:Show()
	
	unitdb.allframes = CreateFrame("StatusBar", 'allframes', UIParent)
	unitdb.allframes:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	unitdb.allframes:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.allframes:SetHeight(10)
	unitdb.allframes:Hide()
	unitdb.allframes:SetPoint('BOTTOMLEFT', unrealtargetssettings['config']['posix'], unrealtargetssettings['config']['posiy'])
	unitdb.allframes:SetStatusBarColor(1,1,1,0)
	unitdb.allframes:SetMovable(false)
	unitdb.allframes:EnableMouse(false)
	unitdb.allframes:SetScript('OnDragStart', unitdb.allframes.StartMoving)
	unitdb.allframes:SetScript('OnDragStop',  function(self, ...)
		self:StopMovingOrSizing()
		unrealtargetssettings['config']['posix'] = self:GetLeft()
		unrealtargetssettings['config']['posiy'] = self:GetBottom()
	end)
	
	local checkname = 'Cheackdragable'
	local checkButton = CreateFrame('CheckButton', checkname, UnrealTargetsPanel, 'UICheckButtonTemplate') --frameType, frameName, frameParent, frameTemplate    
	checkButton:SetPoint("CENTER",0,0)
	checkButton.text = _G[checkname.."Text"]
	checkButton.text:SetText("Lock Enemyframe")
	checkButton:SetPoint('Topleft', 360, -140)
	checkButton:SetChecked(true)
	checkButton:SetScript("OnClick", function(self,event,arg1) 
		local isChecked = checkButton:GetChecked()
		if isChecked then
			unitdb.allframes:EnableMouse(false)
			unitdb.allframes:SetMovable(false)
			unitdb.allframes:UnregisterAllEvents()
		else
			unitdb.allframes:EnableMouse(true)
			unitdb.allframes:SetMovable(true)
			unitdb.allframes:RegisterForDrag('LeftButton')
		end
	end)

	-- myunits.bar = UnrealTargets:set_hp_frame(0, 0, 'mytestbar', UiParent)
	-- local testheightbar = 33
	-- local testwidthbar = 200
	-- myunits.bar:SetWidth(testwidthbar)
	-- myunits.bar:SetHeight(testheightbar)
	-- myunits.fontname = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	-- myunits.fontname:SetPoint("TOPLEFT", 0, 0)
	-- local targetname = UnrealTargets:cut_name("testabcdefghijklmnopqrstuvwxyz")
	-- myunits.fontname:SetText(targetname)
	-- myunits.fontname:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")
	-- myunits.fonthppercent = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	-- myunits.fonthppercent:SetPoint("TOPRIGHT", 0, 0)
	-- myunits.fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")	
	-- myunits.bar:SetMovable(true)
	-- myunits.bar:EnableMouse(true)
	-- myunits.bar:RegisterForDrag("LeftButton")
	-- myunits.bar:SetScript("OnDragStart", myunits.bar.StartMoving)
	-- myunits.bar:SetScript("OnDragStop", myunits.bar.StopMovingOrSizing)
	-- myunits.castbar = UnrealTargets:set_hp_frame(0, -testheightbar/3, 'mytestbarcastline', myunits.bar)
	-- myunits.castbar:SetWidth(testwidthbar)
	-- myunits.castbar:SetHeight(testheightbar/3)
	-- myunits.castbar:SetStatusBarColor(1,0,1)
	-- myunits.castbar:Hide()
	-- local icon = select(3,GetSpellInfo(740))
	-- myunits.icon = CreateFrame("StatusBar", 'mytestbaricon', myunits.bar)
	-- myunits.icon:SetStatusBarTexture(icon)
	-- myunits.icon:SetWidth(testheightbar)
	-- myunits.icon:SetHeight(testheightbar)
	-- myunits.icon:SetPoint("Topleft", -testheightbar, 0)
	-- myunits.icon:Hide()
end

function UnrealTargets:frame_posi_update()
	unitdb.allframes:StopMovingOrSizing()
end

function UnrealTargets:frequently_frame_update(...)
	local guid = UnitGUID(...)
	local mytype, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
	local max_health = UnitHealthMax(...)
	local currenthealth = UnitHealth(...)
	if max_health ~= 0 and currenthealth ~= 0 then
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
			end
		end
	end
	for k, unitguid in ipairs(unitdb.allunitguids) do
		if unitguid == destGUID then
			--unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
			local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
			health = string_format("%.0f", health)
			unitdb.units[destGUID].bar:SetValue(health)
			health = health.."%"
			unitdb.units[destGUID].fonthppercent:SetText(health)
		end
	end
end

function UnrealTargets:frame_update(_, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	local mytype, _, _, _, _, npc_id, _ = strsplit("-",destGUID)
	local sourcetype, _, _, _, _, srcnpc_id, _  = strsplit("-",srcGUID)
	local unit = destName
	local isindb = false
	local ignornpcid = false
	-- if unitdb.zone == false then
		-- print('isopenworld')
	-- end
	-- if event == 'SPELL_MISSED' then
		-- print('missed')
	-- end
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitguid == destGUID then
			if unit ~= "player" then
				--print(hide)
				if event == "UNIT_DIED" then
					table_remove(unitdb.allunitguids, i)
					unitdb.units[unitguid].bar:Hide()
					unitdb.units[unitguid].castbar:Hide()
					self:update_frame_posis()
				elseif event == "SWING_DAMAGE" then
					local _,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "RANGE_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					local _,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
					unitdb.units[destGUID].bar:Show()
					unitdb.units[destGUID].lastupdate = GetTime()
				elseif  event == "SPELL_INTERRUPT" then
					local _, _, spellID, spellname, spellSchool = ...
					local castname, _, icon = GetSpellInfo(spellID)
					unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
					unitdb.units[destGUID].castinterrupt = true
					unitdb.units[destGUID].castTimeend = GetTime()+3
					local green = GREEN_FONT_COLOR 
					unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
					unitdb.units[destGUID].castbar_fontname:SetText('Interrupt')
				elseif event == "SPELL_AURA_APPLIED" then
					local _, _, spellId, spellname, _, auratype = ...
					for i, dbspellID in ipairs(db.silencespells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Silence Interrupt')
							return
						end
					end
					for i, dbspellID in ipairs(db.stunspells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Stun Interrupt')
							return
						end
					end
					for i, dbspellID in ipairs(db.incapacitatesspells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Incapacitates Interrupt')
							--print(spellId)
							return
						end
					end
					for i, dbspellID in ipairs(db.disorientsspells) do
						if spellId == dbspellID then
							local icon = select(3,GetSpellInfo(spellId))
							unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
							unitdb.units[destGUID].castinterrupt = true
							unitdb.units[destGUID].castTimeend = GetTime()+3
							local green = GREEN_FONT_COLOR 
							unitdb.units[destGUID].castbar:SetStatusBarColor(green.r, green.g, green.b)
							unitdb.units[destGUID].castbar_fontname:SetText('Disorients Interrupt')
							--print(spellId)
							return
						end
					end
				end
			end
			isindb = true
		elseif unitguid == srcGUID then
			 if event == 'SPELL_CAST_START' then
				local _, _, spellID, spellname, spellSchool = ...
				_, _, _, unitdb.units[srcGUID].castTime = GetSpellInfo(spellID)
				local castname, _, icon = GetSpellInfo(spellID)
				castname = self:cut_name(castname, 13)
				unitdb.units[srcGUID].castbar_fontname:SetText(castname)
				unitdb.units[srcGUID].icon:Show()
				unitdb.units[srcGUID].icon:SetStatusBarTexture(icon)
				unitdb.units[srcGUID].castbar:Show()
				unitdb.units[srcGUID].castTime =  unitdb.units[srcGUID].castTime/1000
				unitdb.units[srcGUID].castTimeend = unitdb.units[srcGUID].castTime + GetTime()
				local castcolor = {}
				castcolor.r, castcolor.g, castcolor.b = self:get_spellschool_color_code(spellSchool)
				unitdb.units[srcGUID].castbar:SetStatusBarColor(castcolor.r, castcolor.g, castcolor.b)
				unitdb.units[srcGUID].castinterrupt = false
				--print('cast start '..spellname..' '..unitdb.units[srcGUID].castTime)
			-- elseif event == 'SPELL_CAST_FAILED' then
				-- local _, _, spellID, spellname, spellSchool = ...
				-- print('Spell cancel from '..srcName..': spell: '..spellname)
			end
		end
	end
	if not isindb then
		if event == 'RANGE_DAMAGE' 
			or event == 'SPELL_DAMAGE' 
			or event == 'SPELL_PERIODIC_DAMAGE' 
			or event == 'SWING_DAMAGE' then
			--print('true')
			for i, groupguid in ipairs(unitdb.groupmembers) do
				self:insert_target('Creature', 'Vehicle', mytype, sourcetype, npc_id, destName, destGUID, srcGUID, groupguid, srcName, ...)
			end
			for i, petguid in ipairs(unitdb.grouppets) do
				self:insert_target('Creature', 'Vehicle', mytype, sourcetype, npc_id, destName, destGUID, srcGUID, petguid, srcName, ...)
			end
		end
end

function UnrealTargets:insert_target(thetarget1, thetarget2, thesource1, thesource2, npc_id, destName, destGUID, srcGUID, guid, srcName, ...)
	if thesource1 == thetarget1 and srcGUID == guid or thesource1 == thetarget2 and srcGUID == guid then
			--print('true2')
			if unitdb.isinfight == true then
				ignornpcid = self:ignor_npc(npc_id)
				if event == 'SPELL_HEAL' 
					or event == 'SPELL_PERIODIC_HEAL' 
					or event == 'SPELL_AURA_APPLIED' 
					or event == 'SPELL_AURA_REMOVED'
					or event == 'SPELL_AURA_REFRESH'then
					ignornpcid = true
				end
				if ignornpcid == false then
					UnrealTargets:create_frame(npc_id, destName, destGUID)
					if event == "SWING_DAMAGE" then
						local _,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()
					elseif event == "SPELL_DAMAGE" then
						local _,_,_,_,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()
					elseif event == "RANGE_DAMAGE" then
						local _,_,_,_,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()
					elseif event == "SPELL_PERIODIC_DAMAGE" then
						local _,_,_,_,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()--print('add '..event..' '..destName)
					end
				end
			end
		elseif thesource1 == guid and srcGUID == thetarget1 or thesource1 == guid and srcGUID == thetarget2 then
			--print('true3')
			if unitdb.isinfight == true then
				ignornpcid = self:ignor_npc(srcnpc_id)
				for _, unitguid in ipairs(unitdb.allunitguids) do
					if unitguid == srcGUID then
						ignornpcid = true
					end
				end
				if event == 'SPELL_HEAL' 
					or event == 'SPELL_PERIODIC_HEAL' 
					or event == 'SPELL_AURA_APPLIED' 
					or event == 'SPELL_AURA_REMOVED'
					or event == 'SPELL_AURA_REFRESH'then
					ignornpcid = true
				end
				if ignornpcid == false then
					UnrealTargets:create_frame(srcnpc_id, srcName, srcGUID)
					if event == "SWING_DAMAGE" then
						local _,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()
					elseif event == "SPELL_DAMAGE" then
						local _,_,_,_,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()
					elseif event == "RANGE_DAMAGE" then
						local _,_,_,_,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()
					elseif event == "SPELL_PERIODIC_DAMAGE" then
						local _,_,_,_,_, dmg = ...
						self:hp_update(destGUID, dmg)
						unitdb.units[destGUID].bar:Show()
						unitdb.units[destGUID].lastupdate = GetTime()--print('add '..event..' '..srcName)
					end
				end
			end
		end
	end
end

function UnrealTargets:create_frame(npc_id, destName, destGUID)
	SendChatMessage(","..npc_id.." -- "..destName, "CHANNEL", nil,  GetChannelName("myaddon"))
	table_insert(unitdb.allunitguids, destGUID)
	unitdb.units[destGUID] = {}
	if unitdb.unitsmaxhp[npc_id] then
		unitdb.units[destGUID].maxhp = unitdb.unitsmaxhp[npc_id].maxhp
	else
		unitdb.units[destGUID].maxhp = 1000000
	end
	unitdb.allframes:Show()
	unitdb.units[destGUID].lastupdate = GetTime()
	unitdb.units[destGUID].hp = unitdb.units[destGUID].maxhp
	unitdb.units[destGUID].npcid = npc_id
	unitdb.units[destGUID].bar = CreateFrame("StatusBar", 'bar'..destGUID, unitdb.allframes)
	unitdb.units[destGUID].bar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	unitdb.units[destGUID].bar:SetBackdrop({
		bgFile = "Interface/Buttons/GreyscaleRamp64",
		edgeFile = "Interface/Buttons/WHITE8X8",
		edgeSize = 1,
	});
	unitdb.units[destGUID].bar:SetBackdropBorderColor(1,1,1,1);
	unitdb.units[destGUID].bar:SetBackdropColor(1,1,1,0.2);
	unitdb.units[destGUID].bar:GetStatusBarTexture():SetHorizTile(false)
	unitdb.units[destGUID].bar:SetMinMaxValues(0, 100)
	unitdb.units[destGUID].bar:SetValue(100)
	unitdb.units[destGUID].bar:SetPoint('Topleft', 0, -1*(table_getn(unitdb.allunitguids)-1) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
	unitdb.allframes:SetHeight(table_getn(unitdb.allunitguids) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
	unitdb.units[destGUID].bar:SetStatusBarColor(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'])
	unitdb.units[destGUID].bar:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.units[destGUID].bar:SetHeight(unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].fontname = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].fontname:SetPoint("TOPLEFT", 1, -1)
	local targetname = self:cut_name(destName, unrealtargetssettings['config']["barnamecut"])
	unitdb.units[destGUID].fontname:SetText(targetname)
	unitdb.units[destGUID].fontname:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/2,"OUTLINE")
	unitdb.units[destGUID].fonthppercent = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].fonthppercent:SetPoint("TOPRIGHT", -1, -1)
	unitdb.units[destGUID].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/2,"OUTLINE")
	unitdb.units[destGUID].castbar = CreateFrame("StatusBar", 'castbar'..destGUID, unitdb.units[destGUID].bar)
	unitdb.units[destGUID].castbar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	unitdb.units[destGUID].castbar:SetBackdrop({
		bgFile = "Interface/Buttons/GreyscaleRamp64",
		edgeFile = "Interface/Buttons/WHITE8X8",
		edgeSize = 1,
	});
	unitdb.units[destGUID].castbar:SetBackdropBorderColor(1,1,1,1);
	unitdb.units[destGUID].castbar:SetBackdropColor(1,1,1,0.2);
	unitdb.units[destGUID].castbar:GetStatusBarTexture():SetHorizTile(false)
	unitdb.units[destGUID].castbar:SetMinMaxValues(0, 100)
	unitdb.units[destGUID].castbar:SetValue(100)
	unitdb.units[destGUID].castbar:SetPoint('CENTER', unitdb.units[destGUID].bar, 'CENTER', 0, -unrealtargetssettings['config']['height']/3)
	unitdb.units[destGUID].castbar:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.units[destGUID].castbar:SetHeight(unrealtargetssettings['config']['height']/3)
	unitdb.units[destGUID].castbar:SetStatusBarColor(0,0,0)
	unitdb.units[destGUID].castbar:Hide()
	local castname, _, icon = GetSpellInfo(740)
	unitdb.units[destGUID].icon = CreateFrame("StatusBar", 'icon'..destGUID, unitdb.units[destGUID].bar)
	unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
	unitdb.units[destGUID].icon:SetWidth(unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].icon:SetHeight(unrealtargetssettings['config']['height'])
	unitdb.units[destGUID].icon:SetPoint("Topleft", -unrealtargetssettings['config']['height'], 0)
	unitdb.units[destGUID].icon:Hide()
	unitdb.units[destGUID].castTime = 0
	unitdb.units[destGUID].castbar_fontname = unitdb.units[destGUID].castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].castbar_fontname:SetPoint("TOPLEFT", 1, -1)
	castname = self:cut_name(castname, unrealtargetssettings['config']["castbarnamecut"] )
	unitdb.units[destGUID].castbar_fontname:SetText(castname)
	unitdb.units[destGUID].castbar_fontname:SetFont("Fonts\\FRIZQT__.ttf", unrealtargetssettings['config']['height']/3-1,"OUTLINE")
	unitdb.units[destGUID].castbartime = unitdb.units[destGUID].castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	unitdb.units[destGUID].castbartime:SetPoint("TOPRIGHT", -1, -1)
	unitdb.units[destGUID].castbartime:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/3-1,"OUTLINE")
end

function UnrealTargets:update_frame_posis()
	for k, unitguid in ipairs(unitdb.allunitguids) do
		unitdb.units[unitguid].bar:SetPoint('Topleft', 0, -1*(k-1) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
	end
	unitdb.allframes:SetHeight(table_getn(unitdb.allunitguids) * (unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
end

function UnrealTargets:get_spellschool_color_code(colorcode)
	local color = {}
	if colorcode == 1 then
		color.r, color.g ,color.b = 1,1,0
	else
		color.r, color.g ,color.b = 1, 0.1, 0.1
	end
	return color.r, color.g ,color.b
end

function UnrealTargets:cut_name(name, ...)
	local max_length = ... or 15
	local length = string_length(name)
	if length > max_length + 2 then
		name = string_sub(name, 0, max_length)
		name = name..".."
	end
	return name
end

function UnrealTargets:ignor_npc(npc_id)
	for i, unitid in ipairs(unitdb.ignornpc) do
		if tonumber(npc_id) == unitid then
			return true
		end
	end
	return false
end

function UnrealTargets:hp_update(destGUID, dmg)
	dmg = dmg or 0
	unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
	local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
	health = string_format("%.0f", health)
	unitdb.units[destGUID].bar:SetValue(health)
	health = health.."%"
	unitdb.units[destGUID].fonthppercent:SetText(health)
end

function UnrealTargets:npcmaxhp_update()
	local max_health = UnitHealthMax("target")
	local currenthealth = UnitHealth("target")
	if max_health ~= 0 and currenthealth ~= 0 then
		--print("true "..max_health)
		local guid = UnitGUID("target")
		local mytype, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
				if npc_id == unitdb.units[unitguid].npcid then
					local deltahp = unitdb.units[unitguid].maxhp - unitdb.units[unitguid].hp 
					unitdb.units[unitguid].maxhp = max_health
					unitdb.units[unitguid].hp = unitdb.units[unitguid].maxhp -deltahp
					self:hp_update(unitguid, 0)
				end		
			end
		end
	end
end

function UnrealTargets:reset_frames()
	for k, unitguid in ipairs(unitdb.allunitguids) do
		unitdb.units[unitguid].bar:Hide()
		unitdb.units[unitguid].castbar:Hide()
		unitdb.units[unitguid] = {}
		table_remove(unitdb.allunitguids, 0)
	end
	unitdb.allunitguids = {}
	unitdb.units = {}
	unitdb.allframes:SetWidth(unrealtargetssettings['config']['width'])
	unitdb.allframes:Hide()
end

function UnrealTargets:isopenworld()
	local mapopenworld = {
		13 -- Kalimdor
		,772 -- Ahn'Qiraj: The Fallen Kingdom
		,894 -- Ammen Vale
		,43	-- Ashenvale
		,181 -- Azshara
		,464 -- Azuremyst Isle
		,476 -- Bloodmyst Isle
		,890 -- Camp Narache
		,42	-- Darkshore
		,381 -- Darnassus
		,101 -- Desolace
		,4 -- Durotar
		,141 --	Dustwallow Marsh
		,891 --	Echo Isles
		,182 --	Felwood
		,121 --	Feralas
		,795 --	Molten Front
		,241 --	Moonglade
		,606 --	Mount Hyjal
		,9 -- Mulgore
		,11	-- Northern Barrens
		,321 --	Orgrimmar
		,888 --	Shadowglen
		,261 --	Silithus
		,607 --	Southern Barrens
		,81	-- Stonetalon Mountains
		,161 --	Tanaris
		,41	-- Teldrassil
		,471 --	The Exodar
		,61	-- Thousand Needles
		,362 --	Thunder Bluff
		,720 --	Uldum
		,201 --	Un'Goro Crater
		,889 --	Valley of Trials
		,281 --	Winterspring
		
		,14	-- Eastern Kingdoms
		,614 --	Abyssal Depths
		,16	-- Arathi Highlands
		,17 -- Badlands
		,19 -- Blasted Lands
		,29	-- Burning Steppes
		,866 --	Coldridge Valley
		,32	-- Deadwind Pass
		,892 --	Deathknell
		,27 -- Dun Morogh
		,34	-- Duskwood
		,23	-- Eastern Plaguelands
		,30	-- Elwynn Forest
		,462 --	Eversong Woods
		,463 --	Ghostlands
		,545 --	Gilneas
		,611 --	Gilneas City
		,24	-- Hillsbrad Foothills
		,341 --	Ironforge
		,499 --	Isle of Quel'Danas
		,610 --	Kelp'thar Forest
		,35	-- Loch Modan
		,895 --	New Tinkertown
		,37	-- Northern Stranglethorn
		,864 --	Northshire
		,36	-- Redridge Mountains
		,684 --	Ruins of Gilneas
		,685 --	Ruins of Gilneas City
		,28 -- Searing Gorge
		,615 --	Shimmering Expanse
		,480 --	Silvermoon City
		,21 -- Silverpine Forest
		,301 --	Stormwind City
		,689 --	Stranglethorn Vale
		,893 --	Sunstrider Isle
		,38	-- Swamp of Sorrows
		,673 --	The Cape of Stranglethorn
		,26	-- The Hinterlands
		,502 --	The Scarlet Enclave
		,20	-- Tirisfal Glades
		,708 --	Tol Barad
		,709 --	Tol Barad Peninsula
		,700 --	Twilight Highlands
		,382 --	Undercity
		,613 --	Vashj'ir
		,22	-- Western Plaguelands
		,39	-- Westfall
		,40 -- Wetlands
		
		,466 --	Outland
		,475 --	Blade's Edge Mountains
		,465 --	Hellfire Peninsula
		,477 --	Nagrand
		,479 --	Netherstorm
		,473 --	Shadowmoon Valley
		,481 --	Shattrath City
		,478 --	Terokkar Forest
		,467 --	Zangarmarsh
		
		,485 --	Northrend
		,486 --	Borean Tundra
		,510 --	Crystalsong Forest
		,504 --	Dalaran
		,488 --	Dragonblight
		,490 --	Grizzly Hills
		,491 --	Howling Fjord
		,541 --	Hrothgar's Landing
		,492 --	Icecrown
		,493 --	Sholazar Basin
		,495 --	The Storm Peaks
		,501 --	Wintergrasp
		,496 --	Zul'Drak
		
		,751 --	The Maelstrom
		,640 --	Deepholm
		,605 --	Kezan
		,544 --	The Lost Isles
		,737 --	The Maelstrom
		
		,862 --	Pandaria
		,858 --	Dread Wastes
		,929 --	Isle of Giants
		,928 --	Isle of Thunder
		,857 --	Krasarang Wilds
		,809 --	Kun-Lai Summit
		,905 --	Shrine of Seven Stars
		,903 --	Shrine of Two Moons
		,806 --	The Jade Forest
		,873 --	The Veiled Stair
		,808 --	The Wandering Isle
		,951 --	Timeless Isle
		,810 --	Townlong Steppes
		,811 --	Vale of Eternal Blossoms
		,807 --	Valley of the Four Winds
		
		,962 --	Draenor
		,978 --	Ashran
		,941 --	Frostfire Ridge
		,976 --	Frostwall
		,949 --	Gorgrond
		,971 --	Lunarfall
		,950 --	Nagrand
		,947 --	Shadowmoon Valley
		,948 --	Spires of Arak
		,1009 -- Stormshield
		,946 --	Talador
		,945 --	Tanaan Jungle
		,970 --	Tanaan Jungle - Assault on the Dark Portal
		,1011 -- Warspear

	}
	local mapID = GetCurrentMapAreaID()
	for _, mapIDdatabase in ipairs(mapopenworld) do
		if mapID == mapIDdatabase then
			print('true')
			return true
		end
	end
	print('false')
	return false
end

function UnrealTargets:raidgrid()
	local numGroupMembers = GetNumGroupMembers()
	unitdb.groupmembers = {}
	unitdb.grouppets = {}
	if IsInRaid() then
		for i = 1 , numGroupMembers do
			table_insert(unitdb.groupmembers, UnitGUID('raid'..i))
			table_insert(unitdb.grouppets, UnitGUID('raidpet'..i))
			--print(grouptype..'guid: '..UnitGUID('raid'..i))
		end
	elseif IsInGroup() then
		for i = 1 , numGroupMembers-1 do
			table_insert(unitdb.groupmembers, UnitGUID('party'..i))
			table_insert(unitdb.grouppets, UnitGUID('partypet'..i))
			--print(grouptype..'guid: '..UnitGUID('party'..i))
		end
		table_insert(unitdb.groupmembers, UnitGUID('Player'))
		table_insert(unitdb.grouppets, UnitGUID('pet'))
	end
	--print('Numbers: '..numGroupMembers)
	if numGroupMembers == 0 then
		table_insert(unitdb.groupmembers, UnitGUID('Player'))
		table_insert(unitdb.grouppets, UnitGUID('pet'))
		--print('Playerguid: '..UnitGUID('Player'))
	end
end

function UnrealTargets:change_zone()
	unitdb.zone = self:isopenworld()
	print('zone change'.. GetCurrentMapAreaID())
end
-- function UnrealTargets:unit_target(...)
	-- local arg1 = ... or "player"
	-- local sourcename = UnitName(arg1)
	-- local name = UnitName(arg1.."target") or "no target"
	-- print(sourcename..": "..name)
-- end

-- function UnrealTargets:unit_mouseover(...)
	-- local arg1 = ... or "player"
	-- local sourcename = UnitName(arg1)
	-- local name = UnitName(arg1.."target")
	-- print("mouseover "..sourcename..": "..name)
-- end

UnrealTargets:SetScript("OnUpdate", function(self, frame) 
	-- if myunits.castTime ~= 0 then
		-- local value = myunits.castTimeend - GetTime()
		-- if value >= 0 then
			-- local value2 = value/myunits.castTime
			-- myunits.castbar:SetValue((1-value2)*100)
			-- --print(value2)
		-- else
			-- myunits.castTime = 0
			-- myunits.castbar:Hide()
			-- myunits.icon:Hide()
		-- end
	-- end
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitdb.units[unitguid].castTime ~= 0 then
			local remaining_time = unitdb.units[unitguid].castTimeend - GetTime()
			if remaining_time >= 0 then
				if unitdb.units[unitguid].castinterrupt == false then
					local value2 = remaining_time/unitdb.units[unitguid].castTime
					unitdb.units[unitguid].castbar:SetValue((1-value2)*100)
					unitdb.units[unitguid].castbar:Show()
					unitdb.units[unitguid].icon:Show()
					remaining_time = string_format("%.1f", remaining_time)
					unitdb.units[unitguid].castbartime:SetText(remaining_time)				
				end
			else
				unitdb.units[unitguid].castinterrupt = false
				unitdb.units[unitguid].castTime = 0
				unitdb.units[unitguid].castbar:Hide()
				unitdb.units[unitguid].icon:Hide()
			end
		end
		if unitdb.units[unitguid].lastupdate + 10 < GetTime() then
			for i, destGUID in ipairs(unitdb.allunitguids) do
				if destGUID == unitguid then
					table_remove(unitdb.allunitguids, i)
					unitdb.units[unitguid].bar:Hide()
					unitdb.units[unitguid].castbar:Hide()
					self:update_frame_posis()
				end
			end
		end
	end
	--collectgarbage()
	--ResetCPUUsage()
end)

function UnrealTargets:OnEvent(event, ...)
	if event == 'PLAYER_LOGIN' then
		self:Initialize(...)
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		self:frame_update(...)
	elseif event == 'PLAYER_TARGET_CHANGED' then
		self:npcmaxhp_update()
	elseif event == 'ENCOUNTER_END' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'PLAYER_REGEN_ENABLED' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'ENCOUNTER_START' then
		unitdb.isinfight = true
	elseif event == 'PLAYER_REGEN_DISABLED' then
		unitdb.isinfight = true
	elseif event == 'ADDON_LOADED' then
		self:mysettings(...)
		--self:change_zone()
		--self:change_zone()
	elseif event == 'UNIT_HEALTH_FREQUENT' then
		self:frequently_frame_update(...)
	elseif event == 'GROUP_ROSTER_UPDATE' then
		self:raidgrid()	
	--elseif event == 'ZONE_CHANGED_NEW_AREA' then
		--self:change_zone()
	-- elseif event == 'UNIT_TARGET' then
		-- self:unit_target(...)
	-- elseif event == 'UPDATE_MOUSEOVER_UNIT' then
		-- self:unit_mouseover(...)
	end
	return
end

function OnEvent(self, event, ...)
	UnrealTargets:OnEvent(event, ...)
end



UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:RegisterEvent('PLAYER_LOGIN')
UnrealTargets:RegisterEvent('UNIT_HEALTH_FREQUENT')
UnrealTargets:RegisterEvent('PLAYER_TARGET_CHANGED')
UnrealTargets:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
UnrealTargets:RegisterEvent('ENCOUNTER_END')
UnrealTargets:RegisterEvent('PLAYER_REGEN_ENABLED')
UnrealTargets:RegisterEvent('ENCOUNTER_START')
UnrealTargets:RegisterEvent('ADDON_LOADED')
--UnrealTargets:RegisterEvent('ZONE_CHANGED_NEW_AREA')
--UnrealTargets:RegisterEvent('UNIT_TARGET')
--UnrealTargets:RegisterEvent('UPDATE_MOUSEOVER_UNIT')
UnrealTargets:RegisterEvent('PLAYER_REGEN_DISABLED')
UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:SetScript('OnEvent', OnEvent)



